#Monoflop
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           d       : in std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt   : std_logic_vector(|Bits-| downto 0);
signal trig0 : std_logic;
signal trig1 : std_logic;
begin
 mf: PROCESS(clk,trigger)
     BEGIN 
       IF (clk'event and clk='|Taktflanke|') THEN 
          IF trigger = '|Trigger|' THEN trig0 <= '1';
                           ELSE trig0 <= '0';
          END IF;  
          trig1 <= trig0;
 
          IF cnt > 0 THEN q <= '1';
                          cnt <= cnt -1;
                     ELSE q <= '0';

                           IF trig0 ='1' and trig1='0' THEN cnt <= d; --delay time
                           END IF;
          END IF;
       END IF;
     END PROCESS mf;

end Behavioral;
>


#Monoflop with reset
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           rst     : in std_logic; 
           d       : in std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt   : std_logic_vector(|Bits-| downto 0);
signal trig0 : std_logic;
signal trig1 : std_logic;
begin
 mf: PROCESS(clk,trigger,rst)
     BEGIN
       IF (rst = '|Reset|') THEN q<= '0';
                           cnt <= |$0,Bits|;
                           trig0 <= '0';
                           trig1 <= '0';
   
         ELSIF (clk'event and clk='|Taktflanke|') THEN 
              IF trigger = '|Trigger|' THEN trig0 <= '1';
                               ELSE trig0 <= '0';
              END IF;  
              trig1 <= trig0;
 
              IF cnt > 0 THEN q <= '1';
                              cnt <= cnt -1;
                         ELSE q <= '0';

                              IF trig0 ='1' and trig1='0' THEN cnt <= d; --delay time
                              END IF;
              END IF;
       END IF;
     END PROCESS mf;

end Behavioral;
>


#Monoflop with counter value
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           d       : in std_logic_vector(|Bits-| downto 0); 
           qcnt    : out std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt   : std_logic_vector(|Bits-| downto 0);
signal trig0 : std_logic;
signal trig1 : std_logic;
begin
 mf: PROCESS(clk,trigger)
     BEGIN 
       IF (clk'event and clk='|Taktflanke|') THEN 
          IF trigger = '|Trigger|' THEN trig0 <= '1';
                           ELSE trig0 <= '0';
          END IF;  
          trig1 <= trig0;
 
          IF cnt > 0 THEN q <= '1';
                          cnt <= cnt -1;
                     ELSE q <= '0';

                           IF trig0 ='1' and trig1='0' THEN cnt <= d; --delay time
                           END IF;
          END IF;
       END IF;
     END PROCESS mf;

     qcnt <= cnt;
end Behavioral;
>


#Monoflop with reset and counter value
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           rst     : in std_logic; 
           d       : in std_logic_vector(|Bits-| downto 0); 
           qcnt    : out std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt   : std_logic_vector(|Bits-| downto 0);
signal trig0 : std_logic;
signal trig1 : std_logic;
begin
 mf: PROCESS(clk,trigger,rst)
     BEGIN
       IF (rst = '|Reset|') THEN q<= '0';
                           cnt <= |$0,Bits|;
                           trig0 <= '0';
                           trig1 <= '0';
   
         ELSIF (clk'event and clk='|Taktflanke|') THEN 
              IF trigger = '|Trigger|' THEN trig0 <= '1';
                               ELSE trig0 <= '0';
              END IF;  
              trig1 <= trig0;
 
              IF cnt > 0 THEN q <= '1';
                              cnt <= cnt -1;
                         ELSE q <= '0';

                              IF trig0 ='1' and trig1='0' THEN cnt <= d; --delay time
                              END IF;
              END IF;
       END IF;
     END PROCESS mf;

     qcnt <= cnt;
end Behavioral;
>


#retrigger Monoflop
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           d       : in std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt  : std_logic_vector(|Bits-| downto 0);
signal trig : std_logic;
begin
 mf: PROCESS(clk,trigger)
     BEGIN 
       IF (clk'event and clk='|Taktflanke|') THEN 
          IF trigger = '|Trigger|' THEN trig <= '1';
                           ELSE trig <= '0';
          END IF;  
 
          IF cnt > 0 THEN q <= '1';
                          cnt <= cnt -1;
                     ELSE q <= '0';

                           IF trig ='1' THEN cnt <= d; --delay time
                           END IF;
          END IF;
       END IF;
     END PROCESS mf;

end Behavioral;
>


#retrigger Monoflop with reset
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           rst     : in std_logic; 
           d       : in std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt  : std_logic_vector(|Bits-| downto 0);
signal trig : std_logic;
begin
 mf: PROCESS(clk,trigger,rst)
     BEGIN
       IF (rst = '|Reset|') THEN q<= '0';
                           cnt <= |$0,Bits|;
                           trig0 <= '0';
                           trig1 <= '0';
   
         ELSIF (clk'event and clk='|Taktflanke|') THEN 
              IF trigger = '|Trigger|' THEN trig <= '1';
                               ELSE trig <= '0';
              END IF;  
 
              IF cnt > 0 THEN q <= '1';
                              cnt <= cnt -1;
                         ELSE q <= '0';

                              IF trig ='1' THEN cnt <= d; --delay time
                              END IF;
              END IF;
       END IF;
     END PROCESS mf;

end Behavioral;
>


#retrigger Monoflop with counter value
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           d       : in std_logic_vector(|Bits-| downto 0); 
           qcnt    : out std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt  : std_logic_vector(|Bits-| downto 0);
signal trig : std_logic;
begin
 mf: PROCESS(clk,trigger)
     BEGIN 
       IF (clk'event and clk='|Taktflanke|') THEN 
          IF trigger = '|Trigger|' THEN trig <= '1';
                           ELSE trig <= '0';
          END IF;  
 
          IF cnt > 0 THEN q <= '1';
                          cnt <= cnt -1;
                     ELSE q <= '0';

                           IF trig ='1' THEN cnt <= d; --delay time
                           END IF;
          END IF;
       END IF;
     END PROCESS mf;

     qcnt <= cnt;
end Behavioral;
>


#retrigger Monoflop with reset and counter value
-Bits[1..36]
-Taktflanke[1,0]
-Trigger[1,0]
-Reset[1,0]
<
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity |Name| is                     
    Port ( trigger : in std_logic;
           clk     : in std_logic;
           rst     : in std_logic; 
           d       : in std_logic_vector(|Bits-| downto 0); 
           qcnt    : out std_logic_vector(|Bits-| downto 0); 
           q       : out std_logic);       
end |Name|;

architecture Behavioral of |Name| is 
signal cnt  : std_logic_vector(|Bits-| downto 0);
signal trig : std_logic;
begin
 mf: PROCESS(clk,trigger,rst)
     BEGIN
       IF (rst = '|Reset|') THEN q<= '0';
                           cnt <= |$0,Bits|;
                           trig <= '0';
   
         ELSIF (clk'event and clk='|Taktflanke|') THEN 
              IF trigger = '|Trigger|' THEN trig <= '1';
                               ELSE trig <= '0';
              END IF;  
 
              IF cnt > 0 THEN q <= '1';
                              cnt <= cnt -1;
                         ELSE q <= '0';

                              IF trig ='1' THEN cnt <= d; --delay time
                              END IF;
              END IF;
       END IF;
     END PROCESS mf;

     qcnt <= cnt;
end Behavioral;
>

