unit u_automat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, Grids, StdCtrls, ExtCtrls, u_datei, u_fehler;

type
  TAutomatForm = class(TForm)
    MainMenu1: TMainMenu;
    Beenden1: TMenuItem;
    Vorgaben1: TMenuItem;
    Eingangsmatrix1: TMenuItem;
    Ausgangsmatrix1: TMenuItem;
    Zustandsmatrix1: TMenuItem;
    Neu1: TMenuItem;
    aktuelleArbeit1: TMenuItem;
    N1: TMenuItem;
    Beenden2: TMenuItem;
    Hilfe1: TMenuItem;
    Speichern1: TMenuItem;
    Statemaschine1: TMenuItem;
    ErzeugeVHDLDatei1: TMenuItem;
    StatusBar1: TStatusBar;
    TabControl1: TTabControl;
    AutomatGrid: TStringGrid;
    Bearbeiten1: TMenuItem;
    GB1: TGroupBox;
    Panel1: TPanel;
    VarMemo: TMemo;
    N3: TMenuItem;
    Automatenbeschreibung: TMenuItem;
    Eingangsmatrix2: TMenuItem;
    Ausgangsmatrix2: TMenuItem;
    Zustandsmatrix2: TMenuItem;
    Label1: TLabel;
    BitEdit: TEdit;
    Automatentabelle1: TMenuItem;
    Ausgangstabelle1: TMenuItem;
    AutomatPopupMenu: TPopupMenu;
    Panel2: TPanel;
    Label2: TLabel;
    RSTCBox: TComboBox;
    CLKRST: TMenuItem;
    ResetCheckBox: TCheckBox;
    CLKCheckBox: TCheckBox;
    Label3: TLabel;
    procedure Init(prgpath, sourepath : string; Automat : boolean);
    procedure Neu1Click(Sender: TObject);
    procedure aktuelleArbeit1Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure Beenden2Click(Sender: TObject);
    procedure Eingangsmatrix1Click(Sender: TObject);
    procedure Ausgangsmatrix1Click(Sender: TObject);
    procedure Zustandsmatrix1Click(Sender: TObject);
    procedure ErzeugeVHDLDatei1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TabControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure TabControl1Change(Sender: TObject);
    procedure VarMemoKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure Eingangsmatrix2Click(Sender: TObject);
    procedure Ausgangsmatrix2Click(Sender: TObject);
    procedure Zustandsmatrix2Click(Sender: TObject);
    procedure AutomatentabelleClick(Sender: TObject);
    procedure Ausgangstabelle1Click(Sender: TObject);
    procedure BitEditKeyPress(Sender: TObject; var Key: Char);
    procedure AutomatGridKeyPress(Sender: TObject; var Key: Char);
    procedure AutomatGridContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure AutomatMenuSelect1Click(Sender: TObject);
    procedure AutomatMenuSelect2Click(Sender: TObject);
    procedure VarMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VarMemoExit(Sender: TObject);
    procedure Statemaschine1Click(Sender: TObject);
    procedure RSTCBoxChange(Sender: TObject);
    procedure CLKRSTClick(Sender: TObject);
    procedure VarMemoChange(Sender: TObject);
    procedure Hilfe1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    progpath, srcpath    : string;
    rstzustand           : string;
    Aedit,Atyp           : boolean; //Atyp true = Moore false = Mealy
    iMode,InBits,OutBits : integer;
    Brst,Bclk            : string;
    VE,VA,VZ,TA,TM       : TStringList;
    procedure Mode(mtyp : integer);
    function GetMode : integer;
    procedure WriteMemo;
    procedure ReadMemo;
    procedure ReadDoc;
    procedure WriteDoc;
    procedure WriteAutomatGrid;
    procedure ReadAutomatGrid;
    function GetConstStr(s : string;len : integer) : string;
    procedure CopyZustand;
    procedure Automatpopupmenuclear;
    function deleteund(s:string) : string;
    procedure NewGridZeile(Zeile : integer);
    procedure DeleteGridZeile(Zeile : integer; doppelt : boolean);
    function StringVorhanden(strList : TStrings) : boolean;
    procedure DeleteStringdoppelt(strList : TStringList);
    function GetMatrixEnable : boolean;
    function TesteTabelle : longint;
    function TesteMatrixFelder(strList : TStringList;ts : string) : boolean;
    function TesteTabellenFelder(strList : TStringList) : boolean;
    function GetOutSignalfromState(Z:string) : string;
    procedure GetStateData(var Z:string;var E:string;var ZN : string;
                           inputstring : string);
    procedure GetStateDataMealy(var Z:string;var E:string;var ZN : string;
                                var A:string;inputstring : string);
    function GetState(input:string) : string;
    function GetBusWidht(strlist : TStringList) : integer;
    function dellzl(s:string) : string;     //entferne Leerzeichen von links
    function dellzr(s:string) : string;     //entferne Leerzeichen von rechts
  public
    { Public-Deklarationen }
    function GetBits(i : integer) : integer;
  end;

var
  AutomatForm: TAutomatForm;

implementation

{$R *.DFM}

procedure TAutomatForm.FormCreate(Sender: TObject);
begin
  Aedit:= false;
  VE:= TStringList.Create;
  VA:= TStringList.Create;
  VZ:= TStringList.Create;
  TA:= TStringList.Create;
  TM:= TStringList.Create;
  inBits:= 0;
  outBits:= 0;
  rstzustand:= '';
  Brst:='1';
  Bclk:='1';
  ResetCheckBox.checked:= false;
  ClkCheckBox.checked:= false;
end;

procedure TAutomatForm.FormDestroy(Sender: TObject);
begin
  if Aedit then
  begin
    if Application.MessageBox('Daten speichern?','Frage',mb_YESNO) = ID_YES then
    begin
      Speichern1Click(Self);
      Aedit:= false;
    end;
  end;

  Automatpopupmenuclear;
  VE.Free;
  VA.Free;
  VZ.Free;
  TA.Free;
  TM.Free;
end;

procedure TAutomatForm.FormResize(Sender: TObject);
begin
  if width < VarMemo.Width then
  begin
    width:= VarMemo.Width;
    Panel1.Width:= 0;
  end
  else begin
         Panel1.Width:= width - VarMemo.Width;
       end;
  if height < 300 then height:= 300;
end;

procedure TAutomatForm.Init(prgpath, sourepath : string; Automat : boolean);
begin
  progpath:= prgpath;
  srcpath:= srcpath;
  ATyp:= Automat;
  Mode(0);
  if Atyp = true then
  begin
    Caption:= 'Moore - Automat';
    HelpContext:= 3000;
    AutomatGrid.HelpContext:= 3100;
  end
  else begin
         Caption:= 'Mealy - Automat';
         HelpContext:=4000;
         AutomatGrid.HelpContext:= 4100;
       end;
end;

procedure TAutomatForm.Mode(mtyp : integer);
begin
  StatusBar1.SimpleText:= '';

  if iMode <> mtyp then
  begin //vor dem Mode aendern
    case iMode of
    1:  ReadMemo;
    2:  ReadAutomatGrid;
    end;
  end;

  iMode:= mtyp;
  case mtyp of
  0:   begin
         TabControl1.Visible:= false;
         AutomatGrid.Visible:= false;
         ErzeugeVHDLDatei1.Enabled:= false;
         GB1.Visible:= false;
         Speichern1.Enabled:= false;
         Statemaschine1.Enabled:= false;

         TabControl1.Tabs.Clear;
         TabControl1.Tabs.Add('Eingangsmatrix');
         TabControl1.Tabs.Add('Ausgangsmatrix');
         TabControl1.Tabs.Add('Zustandsmatrix');
         TabControl1.Tabs.Add('Takt und Reset');
       end;
  1:   begin
         TabControl1.Visible:= true;
         AutomatGrid.Visible:= false;
         ErzeugeVHDLDatei1.Enabled:= false;
         GB1.Visible:= true;
         Speichern1.Enabled:= true;
         Statemaschine1.Enabled:= true;
         if atyp = true then Ausgangstabelle1.Visible:= true
                        else Ausgangstabelle1.Visible:= false;

         TabControl1.Tabs.Clear;
         TabControl1.Tabs.Add('Eingangsmatrix');
         TabControl1.Tabs.Add('Ausgangsmatrix');
         TabControl1.Tabs.Add('Zustandsmatrix');
         TabControl1.Tabs.Add('Takt und Reset');
         if atyp = true then
         begin
           AutomatGrid.HelpContext:= 3100;
         end
         else begin
                AutomatGrid.HelpContext:= 4100;
              end;
       end;
  2:   begin
         GB1.Visible:= false;
         TabControl1.Visible:= true;
         AutomatGrid.Visible:= true;
         ErzeugeVHDLDatei1.Enabled:= true;
         TabControl1.TabIndex:= 0;
         Speichern1.Enabled:= true;
         Statemaschine1.Enabled:= true;

         TabControl1.Tabs.Clear;
         TabControl1.Tabs.Add('Eingangsmatrix');
         TabControl1.Tabs.Add('Ausgangsmatrix');
         TabControl1.Tabs.Add('Zustandsmatrix');
         TabControl1.Tabs.Add('Automatentabelle');
         Ausgangstabelle1.Visible:= false;
         if atyp = true then  //Moore
         begin
           TabControl1.Tabs.Add('Ausgangstabelle');
           Ausgangstabelle1.Visible:= true;
           AutomatGrid.HelpContext:= 3110;
           AutomatPopUpMenu.HelpContext:= 3110;
         end
         else begin
                AutomatGrid.HelpContext:= 4110;
                AutomatPopUpMenu.HelpContext:= 4110;
              end;
       end;
  end;
end;

function TAutomatForm.dellzl(s:string) : string;     //entferne Leerzeichen von links
var i : integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[1] = ' ' then delete(s,1,1)
                  else i:=1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

function TAutomatForm.dellzr(s:string) : string;     //entferne Leerzeichen von rechts
var i :integer;
begin
  i:= length(s);
  while i > 0 do
  begin
    if s[i] = ' ' then delete(s,i,1)
                  else i:= 1; //Abbruch
    dec(i);
  end;
  result:= s;
end;

function TAutomatForm.GetMode : integer;
begin
  result:= iMode;
end;

function TAutomatForm.GetBits(i : integer) : integer;
var x,n : integer;
begin
  n:= i;
  if n > 1 then dec(n);
  x:= 0;
  while n > 0 do
  begin
    inc(x);
    n:= n shr 1;
  end;
  result:= x;
end;

procedure TAutomatForm.ReadDoc;
var FDoc    : TEXTFILE;
    Datei,s : string;
    i       : integer;
begin
  if Atyp then Datei:= progpath + 'Moore.txt'
          else Datei:= progpath + 'Mealy.txt';
  if fileexists(Datei) then
  begin
    assignfile(FDoc,Datei);
    {$I-}
    reset(FDoc);
    {$I+}
    if ioresult = 0 then
    begin
      //lesen
      VE.Clear;
      VA.Clear;
      VZ.Clear;

      i:= 0;
      while not eof(FDoc) do
      begin
        readln(FDoc,s);
        if s <> '' then
        begin
          if s[1] <> '#' then
          begin
            case i of
            1: VE.Add(s);
            2: VA.Add(s);
            3: VZ.Add(s);
            4: TM.Add(s);
            5: TA.Add(s);
            end;
          end;
          if pos('#IN',uppercase(s)) > 0 then i:= 1;
          if pos('#OUT',uppercase(s)) > 0 then i:= 2;
          if pos('#Z',uppercase(s)) > 0 then i:= 3;
          if pos('#AUTOMAT',uppercase(s)) > 0 then i:= 4;
          if pos('#AUSGTAB',uppercase(s)) > 0 then i:= 5;
          if pos('#IB',uppercase(s)) > 0 then
          begin
            inBits:= strtointdef(copy(s,4,length(s)-3),0);
          end;
          if pos('#OB',uppercase(s)) > 0 then
          begin
            outBits:= strtointdef(copy(s,4,length(s)-3),0);
          end;
          if pos('#RST',uppercase(s)) > 0 then
          begin
            rstzustand:= copy(s,5,length(s)-4);
          end;
          if pos('#BRST',uppercase(s)) > 0 then
          begin
            Brst:= copy(s,6,1);
          end;
          if pos('#BCLK',uppercase(s)) > 0 then
          begin
            Bclk:= copy(s,6,1);
          end;
        end;
      end;
      {$I-}
      closefile(FDoc);
      {$I+}
    end;
  end;
end;

procedure TAutomatForm.WriteDoc;
var FDoc    : TEXTFILE;
    Datei   : string;
    i       : integer;
begin
  if Atyp then Datei:= progpath + 'Moore.txt'
          else Datei:= progpath + 'Mealy.txt';

  assignfile(FDoc,Datei);
  {$I-}
  rewrite(FDoc);
  {$I+}
  if ioresult = 0 then
  begin
    //schreiben
    writeln(FDoc,'#IB' + inttostr(inBits));
    writeln(FDoc,'#OB' + inttostr(outBits));
    writeln(FDoc,'#IN');
    if VE.Count > 0 then
    begin
      for i:= 0 to VE.Count-1 do
      begin
        writeln(FDoc,VE.Strings[i]);
      end;
    end;

    writeln(FDoc,'#OUT');
    if VA.Count > 0 then
    begin
      for i:= 0 to VA.Count-1 do
      begin
        writeln(FDoc,VA.Strings[i]);
      end;
    end;

    writeln(FDoc,'#Z');
    if VZ.Count > 0 then
    begin
      for i:= 0 to VZ.Count-1 do
      begin
        writeln(FDoc,VZ.Strings[i]);
      end;
    end;

    writeln(FDoc,'#AUTOMAT');
    if TM.Count > 0 then
    begin
      for i:= 0 to TM.Count-1 do
      begin
        writeln(FDoc,TM.Strings[i]);
      end;
    end;

    writeln(FDoc,'#AUSGTAB');
    if TA.Count > 0 then
    begin
      for i:= 0 to TA.Count-1 do
      begin
        writeln(FDoc,TA.Strings[i]);
      end;
    end;

    if rstzustand <> '' then
    begin
      writeln(FDoc,'#RST' + rstzustand);
    end;

    if Brst <> '' then
    begin
      writeln(FDoc,'#BRST' + Brst);
    end;

    if Bclk <> '' then
    begin
      writeln(FDoc,'#BCLK' + Bclk);
    end;

    {$I-}
    closefile(FDoc);
    {$I+}
  end;
end;

procedure TAutomatForm.TabControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin //vor dem Wechsel
  case GetMode of
  1 : ReadMemo;
  2 : ReadAutomatGrid;
  end;
end;

procedure TAutomatForm.TabControl1Change(Sender: TObject);
begin  //nach dem Wechsel
  case GetMode of
  1 : begin
        case TabControl1.TabIndex of
        0: Eingangsmatrix1Click(Self);
        1: Ausgangsmatrix1Click(Self);
        2: Zustandsmatrix1Click(Self);
        3: CLKRSTClick(Self);
        end;
      end;
  2 : begin
        case TabControl1.TabIndex of
        0: Eingangsmatrix2Click(Self);
        1: Ausgangsmatrix2Click(Self);
        2: Zustandsmatrix2Click(Self);
        3: AutomatentabelleClick(Self);
        4: if atyp = true then Ausgangstabelle1Click(Self);  //Moore
        end;
      end;
  end; //GetMode
end;

procedure TAutomatForm.WriteMemo;
var strList : TStringList;
    i,n     : integer;
    s       : string;
begin
  strList:= nil;

  case TabControl1.TabIndex of
  0:  begin
        strList:= VE;
        i:= GetBits(strList.Count);
        if i > inBits then inBits:= i;
        BitEdit.Text:= inttostr(inBits);
      end;
  1:  begin
        strList:= VA;
        i:= GetBits(strList.Count);
        if i > outBits then outBits:= i;
        BitEdit.Text:= inttostr(outBits);
      end;
  2:  begin
        strList:= VZ;
        RSTCBox.Items.Clear;
        if strList.Count > 0 then
        begin
          for i:= 0 to strList.Count-1 do
          begin
            s:= strList.Strings[i];
            n:= pos('|',s);
            if n > 0 then s:= copy(s,1,n-1);
            RSTCBox.Items.Add(s);
          end;
        end;
        RSTCBox.ItemIndex:= 0;
        if RSTCBox.Items.Count > 0 then
        begin
          i:= 0;
          while ((i < RSTCBox.Items.Count) and
                 (rstzustand <> RstCBox.Items.Strings[i])) do
          begin
            inc(i);
          end;
          RstCBox.ItemIndex:= i;
        end;
      end;
  3:  begin
        strList:= nil;
        if Brst = '0' then ResetCheckBox.Checked:= true
                      else ResetCheckBox.Checked:= false;
        if Bclk = '0' then CLKCheckBox.Checked:= true
                      else CLKCheckBox.Checked:= false;
      end;
  end; //case

  if strList <> nil then
  begin
    VarMemo.Clear;
    if strList.Count > 0 then
    begin
      for i:= 0 to strList.Count-1 do
      begin
        s:= strList.Strings[i];
        s:= copy(s,1,pos('|',s)-1);
        VarMemo.Lines.Add(s);
      end;
    end;
  end;
end;

procedure TAutomatForm.ReadMemo;
var strList : TStringList;
    i,n     : integer;
    s,sx    : string;
begin
  strList:= nil;

  case TabControl1.TabIndex of
  0:  begin
        strList:= VE;
        i:= strtointdef(BitEdit.Text,0);
        n:= GetBits(VarMemo.Lines.Count);
        if i < n then inBits:= n
                 else inBits:= i;
      end;
  1:  begin
        strList:= VA;
        i:= strtointdef(BitEdit.Text,0);
        n:= GetBits(VarMemo.Lines.Count);
        if i < n then outBits:= n
                 else outBits:= i;
       end;
  2:  begin
        strList:= VZ;
        rstzustand:= RSTCBox.Items.Strings[RSTCBox.Itemindex];
      end;
  3:  begin
        strList:= nil;
        if ResetCheckBox.Checked then Brst:= '0' else Brst:='1';
        if CLKCheckBox.Checked then Bclk:= '0' else Bclk:='1';
      end;
  end;

  if strList <> nil then
  begin
    if VarMemo.Lines.Count > 0 then
    begin
      i:=0;
      while i < VarMemo.Lines.Count do
      begin
        s:= VarMemo.Lines.Strings[i];
        s:= dellzl(s);
        s:= dellzr(s);
        if s = '' then VarMemo.Lines.Delete(i)
                  else inc(i);
      end;

      for i:= 0 to VarMemo.Lines.Count-1 do
      begin
        s:= VarMemo.Lines.Strings[i];
        sx:='';
        if strList.Count > i then
        begin
          sx:= strList.Strings[i];
          n:= pos('|',sx);
          if n > 0 then sx:= copy(sx,n,length(sx)-n+1);
          s:= s + sx;
          strList.Delete(i);
          strList.Insert(i,s);
        end
        else strList.Add(s+'|');
      end;

      if strlist.count > VarMemo.Lines.Count then
      begin
        n:= strlist.count - VarMemo.Lines.Count;
        for i:= 1 to n do
          strlist.delete(strlist.count-1);
      end;
    end
    else begin
           VarMemo.Clear;
           strList.Clear;
         end;

    DeleteStringdoppelt(strList);
  end;
end;

procedure TAutomatForm.WriteAutomatGrid;
var strList    : TStringList;
    CCol,i,n,x : integer;
    s,sinp,sx  : string;
begin
  strList:= nil;
  cCol:= 0;
  sinp:='';

  AutomatGrid.ColCount:= 100;
  AutomatGrid.RowCount:= 100;
  AutomatGrid.Cols[0].Clear;
  AutomatGrid.Rows[0].Clear;
  AutomatGrid.ColCount:= 2;
  AutomatGrid.RowCount:= 2;
  AutomatGrid.FixedCols:=1;
  AutomatGrid.FixedRows:=1;
  AutomatGrid.Options:= AutomatGrid.Options + [goEditing];

  case TabControl1.TabIndex of
  0:  begin //Eingangsmatrix
        strList:= VE;
        cCol:= inBits;
        sinp:= 'X';
      end;
  1:  begin //Ausgangsmatrix
        strList:= VA;
        cCol:= outBits;
        sinp:= 'Y';
      end;
  2:  begin //Zustandsmatrix
        strList:= VZ;
        cCol:= GetBits(strList.Count);
        sinp:= 'X(Z)';
      end;
  3:  begin //Automatentabelle
        strList:= TM;
        AutomatGrid.FixedCols:=0;
        if atyp = false then AutomatGrid.ColCount:=4
                        else AutomatGrid.ColCount:=3;
        AutomatGrid.Options:= AutomatGrid.Options - [goEditing];
      end;
  4:  begin //Ausgangstabelle
        strList:= TA;
        AutomatGrid.ColCount:=2;
        AutomatGrid.Options:= AutomatGrid.Options - [goEditing];
        CopyZustand;
      end;
  end;

  if ((TabControl1.TabIndex < 3) and (strList <> nil)) then
  begin
    if ((cCol = 0) and (strList.Count > 0)) then
    begin
      s:= strList.Strings[0];
      n:= pos('|',s);
      if n > 0 then s:= copy(s,n+1,length(s)-n-1)
               else s:= ''; //es gibt noch keine Eintraege
      if s <> '' then
      begin
        cCol:= length(s);
      end;
    end;

    if cCol > 0 then //es gibt Daten
    begin
      //Tabelle fuellen
      AutomatGrid.ColCount:= cCol +1;
      AutomatGrid.RowCount:= strList.Count +1;

      for i:= 1 to cCol+1 do
        AutomatGrid.Cols[i].Add(sinp + inttostr(cCol-i));

      if strList.Count > 0 then
      begin
        for i:= 0 to strList.Count-1 do
        begin
          s:= strList.Strings[i];
          n:= pos('|',s);
          AutomatGrid.Rows[i+1].Add(copy(s,1,n-1));
          delete(s,1,n);
          if ((s <> '') and (length(s) >= cCol)) then
          begin
            s:= copy(s,length(s)-cCol,cCol);
            for x:= 1 to cCol do
              AutomatGrid.Cells[x,i+1]:=(s[x]);
          end
          else begin  //mit Nullen auffuellen
                 for x:= 1 to cCol do
                   AutomatGrid.Cells[x,i+1]:='0';
               end;
        end;
      end; //if strList.count
    end;
  end;

  if ((TabControl1.TabIndex = 3) and (strList <> nil)) then
  begin
    if strList.Count = 0 then AutomatGrid.RowCount:= 2
                         else AutomatGrid.RowCount:= strList.count+1;
    AutomatGrid.Cols[0].Add('Zustand');
    AutomatGrid.Cols[1].Add('Folgezustand');
    AutomatGrid.Cols[2].Add('Bedingung');
    if atyp = false then AutomatGrid.Cols[3].Add('Ausgang');

    x:= 0;
    for i:= 0 to strList.Count-1 do
    begin
      s:= strList.Strings[i];
      n:= pos('|',s);
      sx:= copy(s,1,n-1);
      AutomatGrid.Cells[0,x+1]:= sx;
      if sx <> '' then
      begin
        s:= copy(s,n+1,length(s)-n);
        n:= pos('|',s);
        if n > 0 then
        begin
          sx:= copy(s,1,n-1);
          delete(s,1,n);
        end
        else begin
               sx:= s;
               s:='';
             end;
        AutomatGrid.Cells[1,x+1]:= sx;

        n:= pos('|',s);
        if n > 0 then
        begin
          sx:= copy(s,1,n-1);
          delete(s,1,n);
        end
        else begin
               sx:= s;
               s:='';
             end;
        AutomatGrid.Cells[2,x+1]:= sx;

        if atyp = false then
        begin
          AutomatGrid.Cells[3,x+1]:= s;
        end;
        inc(x);
      end;
    end;

    if VZ.count > 0 then
    begin
      if strlist.count = 0 then AutomatGrid.RowCount:= AutomatGrid.RowCount -1;
      //nicht vorhandene Zustaende anfuegen
      for x:= 0 to VZ.Count-1 do
      begin
        n:=0;
        for i:= 1 to AutomatGrid.RowCount-1 do
        begin
          s:= uppercase(VZ.Strings[x]);
          s:= copy(s,1,pos('|',s)-1);
          sx:= uppercase(AutomatGrid.Cells[0,i]);
          if s = sx then inc(n);
        end;

        if n = 0 then //Zustand nicht in Tabelle - anfuegen
        begin
          AutomatGrid.RowCount:= AutomatGrid.RowCount +1;
          s:= VZ.Strings[x];
          s:= copy(s,1,pos('|',s)-1);
          AutomatGrid.Cells[0,AutomatGrid.RowCount-1]:= s;
          AutomatGrid.Cells[1,AutomatGrid.RowCount-1]:= '';
          AutomatGrid.Cells[2,AutomatGrid.RowCount-1]:= '';
          if atyp = false then AutomatGrid.Cells[3,AutomatGrid.RowCount-1]:= '';
          Aedit:= true;
        end;
      end;

      //vorhandene Zustaende
      i:= AutomatGrid.RowCount-1;
      while i > 0 do
      begin
        n:=0;
        sx:= uppercase(AutomatGrid.Cells[0,i]);
        for x:= 0 to VZ.Count-1 do
        begin
          s:= uppercase(VZ.Strings[x]);
          s:= copy(s,1,pos('|',s)-1);
          if s = sx then inc(n);
        end;

        if n = 0 then //Zustand in Tabelle vorhanden, aber nicht mehr gueltig
        begin
          DeleteGridZeile(i,false);
          Aedit:= true;
        end ;
        dec(i);
      end;
    end;

    //ueberprfen, ob Tabelleninhalt ok ist
    for i:= 1 to AutomatGrid.RowCount-1 do
    begin
      sx:= uppercase(AutomatGrid.Cells[1,i]);
      n:= 0;
      if VZ.Count > 0 then
      begin
        for x:= 0 to VZ.Count-1 do
        begin
          s:= uppercase(VZ.Strings[x]);
          s:= copy(s,1,pos('|',s)-1);
          if s = sx then inc(n);
        end;
        if n = 0 then //Zustand nicht in Liste, somit in Tabelle loeschen
        begin
          AutomatGrid.Cells[1,i]:= '';
          Aedit:= true;
        end;
      end;
    end;

    for i:= 1 to AutomatGrid.RowCount-1 do
    begin
      sx:= uppercase(AutomatGrid.Cells[2,i]);
      n:= 0;
      if VE.Count > 0 then
      begin
        for x:= 0 to VE.Count-1 do
        begin
          s:= uppercase(VE.Strings[x]);
          s:= copy(s,1,pos('|',s)-1);
          if s = sx then inc(n);
        end;
        if n = 0 then //Zustand nicht in Liste, somit in Tabelle loeschen
        begin
          AutomatGrid.Cells[2,i]:= '';
          Aedit:= true;
        end;
      end;
    end;

    if atyp = false then
    begin
      for i:= 1 to AutomatGrid.RowCount-1 do
      begin
        sx:= uppercase(AutomatGrid.Cells[3,i]);
        n:= 0;
        if VA.Count > 0 then
        begin
          for x:= 0 to VA.Count-1 do
          begin
            s:= uppercase(VA.Strings[x]);
            s:= copy(s,1,pos('|',s)-1);
            if s = sx then inc(n);
          end;
          if n = 0 then //Zustand nicht in Liste, somit in Tabelle loeschen
          begin
            AutomatGrid.Cells[3,i]:= '';
            Aedit:= true;
          end;
        end;
      end;
    end;
    AutomatGrid.FixedRows:=1;
  end;

  if ((TabControl1.TabIndex = 4) and (strList <> nil)) then
  begin
    if strList.Count = 0 then AutomatGrid.RowCount:= 2
                         else AutomatGrid.RowCount:= strList.count+1;
    AutomatGrid.Cols[0].Add('Zustand');
    AutomatGrid.Cols[1].Add('Ausgangsvektor');
    for i:= 0 to strList.Count-1 do
    begin
      s:= strList.Strings[i];
      n:= pos('|',s);
      AutomatGrid.Cells[0,i+1]:= copy(s,1,n-1);
      AutomatGrid.Cells[1,i+1]:= copy(s,n+1,length(s)-n);
    end;

    //ueberprfen, ob Tabelleninhalt ok ist
    for i:= 1 to AutomatGrid.RowCount do
    begin
      sx:= uppercase(AutomatGrid.Cells[1,i]);
      n:= 0;
      if VA.Count > 0 then
      begin
        for x:= 0 to VA.Count-1 do
        begin
          s:= uppercase(VA.Strings[x]);
          s:= copy(s,1,pos('|',s)-1);
          if s = sx then inc(n);
        end;
        if n = 0 then //Zustand nicht in Liste, somit in Tabelle loeschen
        begin
          AutomatGrid.Cells[1,i]:= '';
          Aedit:= true;
        end;
      end;
    end;

  end;
end;

procedure TAutomatForm.ReadAutomatGrid;
var strList    : TStringList;
    CCol,cRow  : integer;
    s,sz       : string;
begin
  strList:= nil;

  case TabControl1.TabIndex of
  0:  strList:= VE;
  1:  strList:= VA;
  2:  strList:= VZ;
  3:  strList:= TM;
  4:  strList:= TA;
  end;

  if strList <> nil then
  begin
    strList.Clear;
    //Zeilen
    for cRow:= 1 to AutomatGrid.RowCount-1 do
    begin
      //Spalten
      s:= AutomatGrid.Cells[0,cRow] + '|';
      for cCol:= 1 to AutomatGrid.ColCount-1 do
      begin
        sz:= AutomatGrid.Cells[cCol,cRow];

        case TabControl1.TabIndex of
        0: if (sz = '') then sz:='0';
        1: if (sz = '') then sz:='0';
        2: if (sz = '') then sz:='0';
        3: if atyp = true then
           begin
             if cCol < 2 then sz:= sz + '|';
           end
           else begin
                  if cCol < 3 then sz:= sz + '|';
                end;
        4: ;
        end; //case

        s:= s + sz;
      end;
      strList.Add(s);
    end;
  end;
end;

procedure TAutomatForm.CopyZustand;
var s,sx    : string;
    i,n,cnt : integer;
begin
  if ((vz <> nil) and (TA <> nil)) then //Daten in 2.Liste uebertragen
  begin
    cnt:= TA.Count;
    if vz.count > 0 then
    begin
      for i:= 0 to vz.count-1 do
      begin
        s:= vz.Strings[i];
        if i < TA.Count then
        begin
          sx:= TA.Strings[i];
          n:= pos('|',sx);
          if n > 0 then delete(sx,1,n);
          sx:= copy(s,1,n) + sx;
          TA.Delete(i);
          TA.Insert(i,sx);
        end
        else begin
               n:= pos('|',s);
               if n = 0 then n:= length(s)+1;
               TA.Add(copy(s,1,n-1) +'|'); //wenn Liste leer
             end;
      end; //for
    end;
    if VZ.count < cnt then
    begin
      n:= cnt - VZ.Count;
      for i:= 1 to n do
        TA.Delete(TA.Count-1);
    end;
  end;
end;

procedure TAutomatForm.Automatpopupmenuclear;
var i  : integer;
    MI : TMenuItem;
begin
  if Automatpopupmenu.Items.Count > 0 then
  begin
    for i:= 0 to Automatpopupmenu.Items.Count-1 do
    begin
      MI:= Automatpopupmenu.Items[0];
      MI.Free;
    end;
  end;
  Automatpopupmenu.Items.Clear;
end;

procedure TAutomatForm.NewGridZeile(Zeile : integer);
var x,y : integer;
begin
  if ((Zeile >= 0) and (Zeile < AutomatGrid.RowCount +1)) then
  begin
    AutomatGrid.RowCount:= AutomatGrid.RowCount+1;
    //Kopiere Zelleinhalte in Grid nach unten
    if zeile < AutomatGrid.RowCount -1 then
    begin
      for y:= AutomatGrid.RowCount-1 downto Zeile+1 do
      begin
        for x:= 0 to AutomatGrid.ColCount-1 do
        begin
          AutomatGrid.Cells[x,y+1]:= AutomatGrid.Cells[x,y];
        end;
      end;
      //neue Zeile mit Inhalt fllen
      for x:= 0 to AutomatGrid.ColCount do
        AutomatGrid.Cells[x,Zeile+1]:= '';

      AutomatGrid.Cells[0,zeile+1]:= AutomatGrid.Cells[0,zeile];
    end;
  end;
end;

procedure TAutomatForm.DeleteGridZeile(Zeile : integer; doppelt : boolean);
var x,y,cnt : integer;
    s : string;
begin
  cnt:= 0;
  if doppelt = true then
  begin
    //gibt es mehr als eine Zeile mit Zustand Z
    s:= AutomatGrid.Cells[0,zeile];
    if s = '' then cnt:= 2
    else begin
           if AutomatGrid.RowCount > 0 then
           begin
             for y:= 1 to AutomatGrid.RowCount do
             begin
               if s = AutomatGrid.Cells[0,y] then inc(cnt);
             end;
           end;
         end;
  end
  else cnt:= 2; //Bedingung des Zeile loeschen immer erfuellen

  //Zeile nur loeschen, wenn mehrfach der Zustand vorhanden ist
  if ((cnt > 1) and (Zeile > 1) and (Zeile < AutomatGrid.RowCount+ 1)) then
  begin
    for y:= Zeile+1 to AutomatGrid.RowCount do
    begin
      for x:= 0 to AutomatGrid.ColCount-1 do
      begin
        AutomatGrid.Cells[x,y-1]:= AutomatGrid.Cells[x,y];
      end;
    end;
    //letzte Zeile im Grid entfernen
    AutomatGrid.RowCount:= AutomatGrid.RowCount -1;
  end;
end;

procedure TAutomatForm.AutomatGridContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
var i,col,x     : integer;
    MI          : TMenuItem;
    s,sx,sa,sb  : string;
    cmpList     : TStrings;
begin
  if TabControl1.TabIndex > 2 then
  begin
    Automatpopupmenuclear;
    //PopupMenu fuellen
    case TabControl1.TabIndex of
    3:  begin //Automatentabelle
          col:= AutomatGrid.Col;
          case col of
          0: begin //Zustand
               MI:= TMenuItem.Create(Automatpopupmenu);
               MI.Caption:= 'Zeile &einfgen';
               MI.OnClick:= AutomatmenuSelect1Click;
               Automatpopupmenu.Items.Add(MI);
               MI:= TMenuItem.Create(Automatpopupmenu);
               MI.Caption:= 'Zeile &lschen';
               MI.OnClick:= AutomatmenuSelect1Click;
               Automatpopupmenu.Items.Add(MI);
             end;
          1: begin //Folgezustand
               MI:= TMenuItem.Create(Automatpopupmenu);
               MI.Caption:= 'Feld &lschen';
               MI.OnClick:= AutomatmenuSelect1Click;
               Automatpopupmenu.Items.Add(MI);

               s:= AutomatGrid.Cells[0,AutomatGrid.Row];
               if VZ.Count > 0 then
               begin
                 for i:= 0 to VZ.Count-1 do
                 begin
                   sx:= copy(VZ.Strings[i],1,pos('|',VZ.Strings[i])-1);
//                   if s <> sx then //nur Folgezustaende zulassen
                   begin
                     MI:= TMenuItem.Create(Automatpopupmenu);
                     MI.Caption:= sx;
                     MI.OnClick:= AutomatmenuSelect1Click;
                     Automatpopupmenu.Items.Add(MI);
                   end;
                 end;
               end;
             end;
          2: begin //Bedingung
               MI:= TMenuItem.Create(Automatpopupmenu);
               MI.Caption:= 'Feld &lschen';
               MI.OnClick:= AutomatmenuSelect1Click;
               Automatpopupmenu.Items.Add(MI);

               if VE.Count > 0 then
               begin
                 cmpList:= TStringList.create;
                 sa:= uppercase (AutomatGrid.Cells[0,AutomatGrid.Row] +
                                 AutomatGrid.Cells[1,AutomatGrid.Row]);
                 for x:= 1 to AutomatGrid.RowCount do
                 begin
                   sb:= uppercase (AutomatGrid.Cells[0,x] +
                                   AutomatGrid.Cells[1,x]);
                   if ((x <> AutomatGrid.Row) and (sa = sb)) then
                   begin  //Es gibt gleichen Zustand und Folgezustand
                     cmpList.Add(AutomatGrid.Cells[2,x]);
                   end;
                 end;

                 for i:= 0 to VE.Count-1 do
                 begin
                   sx:= copy(VE.Strings[i],1,pos('|',VE.Strings[i])-1);
                   if cmpList.Count > 0 then
                   begin
                     for x:= 0 to cmpList.Count-1 do
                     begin
                       if uppercase(sx) = uppercase(cmpList.Strings[x]) then sx:='';
                     end;
                   end;

                   if sx <> '' then
                   begin
                     MI:= TMenuItem.Create(Automatpopupmenu);
                     MI.Caption:= sx;
                     MI.OnClick:= AutomatmenuSelect1Click;
                     Automatpopupmenu.Items.Add(MI);
                   end;
                 end;
                 cmpList.Free;
               end;
             end;
          3: begin //Ausgangszustand
               MI:= TMenuItem.Create(Automatpopupmenu);
               MI.Caption:= 'Feld &lschen';
               MI.OnClick:= AutomatmenuSelect1Click;
               Automatpopupmenu.Items.Add(MI);

               if VA.Count > 0 then
               begin
                 for i:= 0 to VA.Count-1 do
                 begin
                   sx:= copy(VA.Strings[i],1,pos('|',VA.Strings[i])-1);
                   if sx <> '' then
                   begin
                     MI:= TMenuItem.Create(Automatpopupmenu);
                     MI.Caption:= sx;
                     MI.OnClick:= AutomatmenuSelect1Click;
                     Automatpopupmenu.Items.Add(MI);
                   end;
                 end;
               end;
             end;
          end; //case col
        end;
    4:  begin //Ausgangstabelle
          MI:= TMenuItem.Create(Automatpopupmenu);
          MI.Caption:= 'Feld &lschen';
          MI.OnClick:= AutomatmenuSelect2Click;
          Automatpopupmenu.Items.Add(MI);

          if VA.Count > 0 then
          begin
            for i:= 0 to VA.Count-1 do
            begin
              MI:= TMenuItem.Create(Automatpopupmenu);
              MI.Caption:= copy(VA.Strings[i],1,pos('|',VA.Strings[i])-1);
              MI.OnClick:= AutomatmenuSelect2Click;
              Automatpopupmenu.Items.Add(MI);
            end;
          end;
        end;
    end;
    Automatpopupmenu.Popup(Left + MousePos.x,Top + MousePos.y);
  end;
end;

procedure TAutomatForm.AutomatMenuSelect1Click(Sender: TObject);
var MI      : TMenuItem;
    s,sx    : string;
    col,row : integer;
begin
  Aedit:= true;
  with Sender as TMenuItem do
  begin //Caption Menuindex
    if ((MenuIndex < Automatpopupmenu.Items.Count) and (MenuIndex <> -1)) then
    begin
      MI:= Automatpopupmenu.Items[MenuIndex];
      s:= deleteUnd(MI.Caption);
      sx:= uppercase(s);
      col:= AutomatGrid.col;
      row:= AutomatGrid.row;

      case col of
      0: begin //Zustand
           if pos('ZEILE',sx) > 0 then
           begin
             case MenuIndex of
             0 :  NewGridZeile(Row); //Zeile einuegen
             1 :  DeleteGridZeile(Row,true); //Zeile loeschen
             end; //Case
           end;
         end;
      1: begin //Folgezustand
           if pos('FELD',sx) > 0 then
           begin
             AutomatGrid.Cells[col,AutomatGrid.row]:= '';
           end
           else AutomatGrid.Cells[col,AutomatGrid.row]:= s;
         end;
      2: begin //Bedingung
           if pos('FELD',sx) > 0 then
           begin
             AutomatGrid.Cells[col,AutomatGrid.row]:= '';
           end
           else AutomatGrid.Cells[col,AutomatGrid.row]:= s;
         end;
      3: begin //Bedingung
           if pos('FELD',sx) > 0 then
           begin
             AutomatGrid.Cells[col,AutomatGrid.row]:= '';
           end
           else AutomatGrid.Cells[col,AutomatGrid.row]:= s;
         end;
      end; //case col

    end;
  end;
end;

procedure TAutomatForm.AutomatMenuSelect2Click(Sender: TObject);
var MI : TMenuItem;
    s  : string;
begin
  Aedit:= true;
  with Sender as TMenuItem do
  begin //Caption Menuindex
    if ((MenuIndex < Automatpopupmenu.Items.Count) and (MenuIndex <> -1)) then
    begin
      MI:= Automatpopupmenu.Items[MenuIndex];
      s:= deleteUnd(MI.Caption);

      if pos('FELD',uppercase(s)) = 0 then  //keine Eintrge mit Feld xx einfuegen
      begin
        AutomatGrid.Cells[AutomatGrid.col,AutomatGrid.row]:= s;
      end
      else begin
             AutomatGrid.Cells[AutomatGrid.col,AutomatGrid.row]:= '';
           end;
    end;
  end;
end;

procedure TAutomatForm.VarMemoKeyPress(Sender: TObject; var Key: Char);
var i,n,x : integer;
begin
  Aedit:= true;
  if Key in ['A'..'Z','a'..'z','0'..'9',#8,#13] then
   else Key:= #0;

  i:= strtointdef(BitEdit.Text,0);
  n:= 0;
  if VarMemo.Lines.Count > 0 then
  begin
    for x:= 0 to VarMemo.Lines.Count-1 do
       if VarMemo.Lines.Strings[x] <> '' then inc(n);
  end;
  n:= GetBits(n);
  if i < n then BitEdit.Text:= inttostr(n);
end;

procedure TAutomatForm.VarMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if chr(Key) in ['A'..'Z','a'..'z','0'..'9'] then
  else begin
         if StringVorhanden(VarMemo.Lines) then
               StatusBar1.SimpleText:= 'Bezeichner doppelt'
          else StatusBar1.SimpleText:= '';
       end;
end;

procedure TAutomatForm.Neu1Click(Sender: TObject);
begin
  VE.Clear;
  VA.Clear;
  VZ.Clear;
  VarMemo.Lines.Clear;
  Mode(1);
  GetMatrixEnable;
  TabControl1Change(Self);
end;

procedure TAutomatForm.Statemaschine1Click(Sender: TObject);
begin
  GetMatrixEnable;
end;

procedure TAutomatForm.BitEditKeyPress(Sender: TObject; var Key: Char);
var i,n,x : integer;
begin
  Aedit:= true;
  if Key = #13 then
  begin
    i:= strtointdef(BitEdit.Text,0);
    n:= 0;
    if VarMemo.Lines.Count > 0 then
    begin
      for x:= 0 to VarMemo.Lines.Count-1 do
        if VarMemo.Lines.Strings[x] <> '' then inc(n);
    end;
    n:= GetBits(n);
    if i < n then BitEdit.Text:= inttostr(n);
  end;
end;

procedure TAutomatForm.RSTCBoxChange(Sender: TObject);
begin
  if RSTCBox.ItemIndex <> -1 then
  begin
    rstzustand:= RSTCBox.Items.Strings[RSTCBox.ItemIndex];
    RSTCBox.Text:= RSTCBox.Items.Strings[RSTCBox.ItemIndex];
  end;
end;

procedure TAutomatForm.VarMemoChange(Sender: TObject);
var i : integer;
    x : boolean;
begin
  x:= false;
  if VarMemo.Modified then
  begin
    if RSTCBox.Items.Count > 0 then x:= true;
    RSTCBox.Items.Clear;
    for i:= 0 to VarMemo.Lines.Count-1 do
       RSTCBox.Items.Add(VarMemo.Lines.Strings[i]);
    if x then RSTCBox.ItemIndex:= 0;
  end;
end;

procedure TAutomatForm.VarMemoExit(Sender: TObject);
begin
  GetMatrixEnable;
end;

procedure TAutomatForm.AutomatGridKeyPress(Sender: TObject; var Key: Char);
var MousePos: TPoint;
    Handled: Boolean;
begin
  Aedit:= true;
  if TabControl1.TabIndex < 3 then
  begin
    if Key in ['0'..'1',#13] then
                             else Key:= #0;
  end
  else begin
         if Key in [#13] then
         begin
           MousePos:= Mouse.CursorPos;
           AutomatGridContextPopup(Self,MousePos,Handled);
         end;
       end;
end;

procedure TAutomatForm.aktuelleArbeit1Click(Sender: TObject);
begin
  ReadDoc;
  Mode(1);
  GetMatrixEnable;
  TabControl1Change(Self);
  WriteMemo;
end;

procedure TAutomatForm.Speichern1Click(Sender: TObject);
begin
  case GetMode of
  1 : ReadMemo;
  2 : ReadAutomatGrid;
  end;
  WriteDoc;
  GetMatrixEnable;
  Aedit:= false;
end;

procedure TAutomatForm.Beenden2Click(Sender: TObject);
begin
  close;
end;

//Memo
procedure TAutomatForm.Eingangsmatrix1Click(Sender: TObject);
begin
  Mode(1);
  TabControl1.TabIndex:= 0;
  GB1.Caption:= 'Eingangssignale';
  VarMemo.Visible:= true;
  WriteMemo;
  Label1.Visible:= true;
  Label3.Visible:= false;
  BitEdit.Visible:= true;
  BitEdit.HelpContext:= 2140;
  Label2.Visible:= false;
  RSTCBox.Visible:= false;
  ResetCheckBox.Visible:= false;
  ClkCheckBox.Visible:= false;
end;

procedure TAutomatForm.Ausgangsmatrix1Click(Sender: TObject);
begin
  Mode(1);
  TabControl1.TabIndex:= 1;
  GB1.Caption:= 'Ausgangssignale';
  VarMemo.Visible:= true;
  WriteMemo;
  Label1.Visible:= false;
  Label3.Visible:= true;
  BitEdit.Visible:= true;
  BitEdit.HelpContext:= 2150;
  Label2.Visible:= false;
  RSTCBox.Visible:= false;
  ResetCheckBox.Visible:= false;
  ClkCheckBox.Visible:= false;
end;

procedure TAutomatForm.Zustandsmatrix1Click(Sender: TObject);
begin
  Mode(1);
  TabControl1.TabIndex:= 2;
  GB1.Caption:= 'Automatenzustnde';
  VarMemo.Visible:= true;
  WriteMemo;
  Label1.Visible:= false;
  Label3.Visible:= false;
  BitEdit.Visible:= false;
  if atyp = true then
  begin
    RSTCBox.Visible:= true;
    Label2.Visible:= true;
  end;
  ResetCheckBox.Visible:= false;
  ClkCheckBox.Visible:= false;
end;

procedure TAutomatForm.CLKRSTClick(Sender: TObject);
begin
  Mode(1);
  TabControl1.TabIndex:= 3;
  GB1.Caption:= 'Takt und Reset';
  VarMemo.Visible:= false;
  WriteMemo;
  Label1.Visible:= false;
  Label3.Visible:= false;
  BitEdit.Visible:= false;
  Label2.Visible:= false;
  RSTCBox.Visible:= false;
  ResetCheckBox.Visible:= true;
  ClkCheckBox.Visible:= true;
end;

//StringGrid
procedure TAutomatForm.Eingangsmatrix2Click(Sender: TObject);
begin
  Mode(2);
  TabControl1.TabIndex:= 0;
  WriteAutomatGrid;
  AutomatGrid.SetFocus;
end;

procedure TAutomatForm.Ausgangsmatrix2Click(Sender: TObject);
begin
  Mode(2);
  TabControl1.TabIndex:= 1;
  WriteAutomatGrid;
  AutomatGrid.SetFocus;
end;

procedure TAutomatForm.Zustandsmatrix2Click(Sender: TObject);
begin
  Mode(2);
  TabControl1.TabIndex:= 2;
  WriteAutomatGrid;
  AutomatGrid.SetFocus;
end;

procedure TAutomatForm.AutomatentabelleClick(Sender: TObject);
begin
  Mode(2);
  TabControl1.TabIndex:= 3;
  WriteAutomatGrid;
  AutomatGrid.SetFocus;
end;

procedure TAutomatForm.Ausgangstabelle1Click(Sender: TObject);
begin
  Mode(2);
  TabControl1.TabIndex:= 4;
  WriteAutomatGrid;
  AutomatGrid.SetFocus;
end;

//Hilfsfunktionen
function TAutomatForm.GetMatrixEnable : boolean;
begin
  if ((GetMode = 1) and (VarMemo.Modified = true)) then ReadMemo;

  if ((VE.Count > 0) and (VA.Count > 0) and (VZ.Count > 0)) then
  begin
    result:= true;
    Bearbeiten1.Enabled:= true;
    Automatenbeschreibung.Enabled:= true;
  end
  else begin
         result:= false;
         Bearbeiten1.Enabled:= false;
         Automatenbeschreibung.Enabled:= false;
       end;
end;

function TAutomatForm.deleteund(s:string) : string;
var sx : string;
    i  : integer;
begin
  sx:='';
  if length(s) > 0 then
  begin
    for i:= 1 to length(s) do
      if s[i] <> '&' then sx:= sx+ s[i];
  end;
  result:= sx;
end;

function TAutomatForm.StringVorhanden(strList : TStrings) : boolean;
var i,x,len1,len2 : integer;
    s1,s2 : string;
    b : boolean;
begin
  b:= false;
  if strList <> nil then
  begin
    if strList.Count > 1 then
    begin
      for i:= 0 to strList.Count-2 do
      begin
        s1:= uppercase(strList.Strings[i]);
        len1:= length(s1);
        for x:= i+1 to StrList.Count-1 do
        begin
          s2:= uppercase(strList.Strings[x]);
          len2:= length(s2);
          if ((len1 = len2) and (s1 = s2)) then b:= true;
        end;
      end;
    end;
  end;
  result:= b;
end;

procedure TAutomatForm.DeleteStringdoppelt(strList : TStringList);
var i,x,len1,len2 : integer;
    s1,s2 : string;
begin
  if strList <> nil then
  begin
    if strList.Count > 1 then
    begin
      i:= 0;
      while i < strList.Count-1 do
      begin
        s1:= uppercase(strList.Strings[i]);
        len1:= length(s1);
        x:= i+1;
        while x < StrList.Count do
        begin
          s2:= uppercase(strList.Strings[x]);
          len2:= length(s2);
          if ((len1 = len2) and (s1 = s2)) then
          begin
            strList.Delete(x);
          end
          else inc(x);
        end;
        inc(i);
      end;
    end;
  end;
end;

function TAutomatForm.GetConstStr(s : string;len : integer) : string;
var sx,sname,svalue : string;
    n : integer;
begin
  n:= pos('|',s);
  if n > 0 then sname:= copy(s,1,n-1)
           else sname:= s;

  svalue:= copy(s,n+1,length(s)-n);
  if svalue = '' then
  begin
    for n:= 0 to len do
      svalue:= svalue + '0';
  end;

  sx:= 'constant ' + sname + ' : std_logic_vector('+ inttostr(len) +
       ' downto 0) := ' + #$22+ svalue + #$22 + ';';
  result:= sx;
end;

function TAutomatForm.TesteTabelle : longint;
var err : longint;
begin
  err:= 0;

  if VE.Count = 0 then err:= err or $0001; //keine Eingaenge definiert
  if VA.Count = 0 then err:= err or $0002; //keine Ausgaenge definiert
  if VZ.Count < 2 then err:= err or $0004; //weniger als 2 Zustaende definiert
  if not TesteMatrixFelder(VE,'1') then err:= err or $0008; //VE - Felder alle 0
  if not TesteMatrixFelder(VA,'1') then err:= err or $0010; //VA - Felder alle 0
  if not TesteTabellenFelder(TM)   then err:= err or $0020; //TM - Leerfelder vorhanden
  if atyp = true then //Moore
  begin
    if not TesteTabellenFelder(TA)   then err:= err or $0040; //TA - Leerfelder vorhanden
  end;
  result:= err;
end;

function TAutomatForm.TesteMatrixFelder(strList : TStringList;ts : string) : boolean;
var s   : string;
    i,n : integer;
    b   : boolean;
begin
  b:= false;
  if strList.Count > 0 then
  begin
    for i:= 0 to strList.Count-1 do
    begin
      s:= strList.Strings[i];
      n:= pos('|',s);
      if n > 0 then s:= copy(s,n+1,length(s)-n);
      if pos(ts,s) > 0 then b:= true;
    end;
  end;
  result:= b;
end;

function TAutomatForm.TesteTabellenFelder(strList : TStringList) : boolean;
var s,sx : string;
    i,n  : integer;
    b    : boolean;
begin
  b:= true;
  if strList.Count > 0 then
  begin
    for i:= 0 to strList.Count-1 do
    begin
      s:= strList.Strings[i];
      n:= pos('|',s);
      if n > 0 then s:= copy(s,n+1,length(s)-n);

      if length(s) = 0 then b:= false;

      while s <> '' do
      begin
        n:= pos('|',s);
        if n > 0 then
        begin
          sx:= copy(s,1,n-1);
          if sx = '' then b:= false;
          delete(s,1,n);
        end
        else begin
               if s = '' then b:= false;
               s:='';
             end;
      end;
    end;
  end;
  result:= b;
end;

//VHDL-Code erzeugen
function TAutomatForm.GetState(input:string) : string;
var s : string;
    n : integer;
begin
  n:= pos('|',input);
  if n > 0 then s:= copy(input,1,n-1)
           else s:= input;
  result:= s;
end;

function TAutomatForm.GetOutSignalfromState(Z:string) : string;
var s,zx,sx : string;
    i,n     : integer;
begin
  s:='';
  if ((z <> '') and (TA <> nil)) then
  begin
    zx:= uppercase(Z);
    if TA.Count > 0 then
    begin
      i:= 0;
      while i < TA.Count do
      begin
        sx:= uppercase(TA.Strings[i]);
        if zx = copy(sx,1,pos('|',sx)-1) then
        begin
          n:= pos('|',TA.Strings[i]);
          s:= copy(TA.Strings[i],n+1,length(TA.Strings[i])-n);
          i:= TA.Count;
        end
        else inc(i);
      end;
    end;
  end;
  result:= s;
end;

procedure TAutomatForm.GetStateData(var Z:string;var E:string;var ZN : string;inputstring : string);
var n : integer;
    s : string;
begin
  s:= inputstring;
  n:= pos('|',s);

  Z:= copy(s,1,n-1);
  delete(s,1,n);

  n:= pos('|',s);
  ZN:= copy(s,1,n-1);
  delete(s,1,n);
  E:= s;

  if ((Z = '') or (ZN = '') or (E = '')) then
  begin
    Z:= '';
    ZN:= '';
    E:= '';
  end;
end;

procedure TAutomatForm.GetStateDataMealy(var Z:string;var E:string;var ZN : string;
                                         var A:string;inputstring : string);
var n : integer;
    s : string;
begin
  s:= inputstring;
  n:= pos('|',s);

  Z:= copy(s,1,n-1);
  delete(s,1,n);

  n:= pos('|',s);
  ZN:= copy(s,1,n-1);
  delete(s,1,n);
  E:= copy(s,1,n-1);

  delete(s,1,n);
  A:= s;

  if ((Z = '') or (ZN = '') or (E = '') or (A = '')) then
  begin
    Z:= '';
    ZN:= '';
    E:= '';
    A:= '';
  end;
end;

function TAutomatForm.GetBusWidht(strlist : TStringList) : integer;
var x,n : integer;
    s   : string;
begin
  x:= 0;
  if strlist <> nil then
  begin
    if strlist.Count > 0 then
    begin
      s:= strlist.Strings[0];
      n:= pos('|',s);
      if n > 0 then delete(s,1,n)
               else s:= '';
      x:= length(s);         
    end;
  end;
  result:= x;
end;

procedure TAutomatForm.ErzeugeVHDLDatei1Click(Sender: TObject);
var dat             : TDateinameForm;
    fehler          : TErrorForm;
    datei,s,sx,name : string;
    Z,ZN,E,A,lzs    : string;    //Zustand,nextZustand,Eingang,Ausgang,leerzeichen
    ZX,EX           : string;    //Zustand,Eingang
    F_vhd           : TEXTFILE;
    n,i,k,x,len     : integer;   //allg. variablen
    nz,ne,na        : integer;   //bitanzahl fuer zustand,eingang,ausgang
    err             : longint;
    b               : boolean;
begin
  case GetMode of
  1 : ReadMemo;
  2 : ReadAutomatGrid;
  end;

  writedoc;
  aedit:= false;
  err:= TesteTabelle;
  if err <> 0 then
  begin
    Fehler:= TErrorForm.Create(Self);
    Fehler.Init(err);
    Fehler.ShowModal;
    Fehler.Free;
    exit;
  end;

  dat:= TDateinameForm.Create(Self);
  if atyp = true then datei:= 'moore.vhd'
                 else datei:= 'mealy.vhd';
  dat.Init(datei);
  dat.ShowModal;
  datei:= dat.GetDateiname;
  n:= pos('.',datei);
  if n > 0 then name:= copy(datei,1,n-1)
           else name:= datei;
  dat.Free;

  // Erzeuge VHDL
  ne:= inBits;
  nz:= GetBusWidht(vz);
//  na:= GetBusWidht(va);
  na:= outBits;
  if ne > 0 then dec(ne);
  if nz > 0 then dec(nz);
  if na > 0 then dec(na);

  if datei <> '' then
  begin
    datei:= srcpath + datei;
    assignfile(F_vhd,datei);
    {$I-}
    rewrite(F_vhd);
    {$I+}
    if ioresult = 0 then
    begin
      writeln(F_vhd,'library IEEE;');
      writeln(F_vhd,'use IEEE.STD_LOGIC_1164.ALL;');
      writeln(F_vhd,'use IEEE.STD_LOGIC_ARITH.ALL;');
      writeln(F_vhd,'use IEEE.STD_LOGIC_UNSIGNED.ALL;');
      writeln(F_vhd,'');

      writeln(F_vhd,'entity ' + name+ ' is');
      writeln(F_vhd,'    Port(clk,rst : in std_logic;');
      s:= '         x : in std_logic_vector(' + inttostr(ne) + ' downto 0);';
      writeln(F_vhd,s);
      //mealy
      if atyp = false then
      begin
        s:= '         z : inout std_logic_vector(' + inttostr(nz) + ' downto 0);';
        writeln(F_vhd,s);
      end;

      s:= '         y : out std_logic_vector(' + inttostr(na) + ' downto 0));';
      writeln(F_vhd,s);

      writeln(F_vhd,'end ' + name + ';');
      writeln(F_vhd,'');

      writeln(F_vhd,'architecture Behavioral of ' + name + ' is');

      writeln(F_vhd,'-- Eingangsmatrix');
      if ve.Count > 0 then
      begin
        for i:= 0 to ve.Count-1 do
        begin
          s:= '   ' + GetConstStr(ve.Strings[i],ne);
          writeln(F_vhd,s);
        end;
      end;

      writeln(F_vhd,'');

      if not TesteMatrixFelder(VZ,'1') then
      begin  //Synthese uebernimmt Zustandscodieren
        s:= '   type zustand is (';
        if atyp = false then s:= s + 'zx,';
        if vz.count > 0 then
        begin
          for i:= 0 to vz.count-1 do
          begin
            sx:= vz.Strings[i];
            n:= pos('|',sx);
            if n > 0 then sx:= copy(sx,1,n-1);
            s:= s + sx;
            if i < vz.Count-1 then s:= s + ',';
          end;
        end;
        s:= s + ');';
        writeln(F_vhd,s);
        s:= '   signal z : zustand;';
        writeln(F_vhd,s);
      end
      else begin  //Zustandscodierung aus Matrix uebernehmen
             writeln(F_vhd,'-- Zustandsmatrix');
             if vz.Count > 0 then
             begin
               for i:= 0 to vz.Count-1 do
               begin
                 s:= '   ' + GetConstStr(vz.Strings[i],nz);
                 writeln(F_vhd,s);
               end;

               if atyp = false then
               begin
                 sx:='';
                 for i:= 1 to nz+1 do
                   sx:= sx + '-';

                 s:= '   constant zx : std_logic_vector(' + inttostr(n) +
                     ' downto 0) := "' + sx + '";';
                 writeln(F_vhd,s);
               end;
               if atyp = true then
               begin
                 writeln(F_vhd,'');
                 s:= '   signal z : std_logic_vector(' + inttostr(nz) +
                     ' downto 0);';
                 writeln(F_vhd,s);
               end;  
             end;
      end;

      writeln(F_vhd,'');
      writeln(F_vhd,'-- Ausgangsmatrix');
      if va.Count > 0 then
      begin
        for i:= 0 to va.Count-1 do
        begin
          s:= '   ' + GetConstStr(va.Strings[i],na);
          writeln(F_vhd,s);
        end;
      end;

      if atyp = false then  //Mealy
      begin
        sx:= va.Strings[0];
        n:= pos('|',sx);
        if n > 0 then delete(sx,1,n);
        len:= length(sx);
        sx:='';
        for i:= 1 to len do
           sx:= sx + '-';

           s:= '   constant yx : std_logic_vector(' + inttostr(n) +
               ' downto 0) := "' + sx + '";';

                 writeln(F_vhd,s);

        writeln(F_vhd,'');
        writeln(F_vhd,'-- Folgezustand');
        s:= '   signal zn : std_logic_vector(' + inttostr(nz) +
            ' downto 0);';
        writeln(F_vhd,s);
      end;

      writeln(F_vhd,'');
      writeln(F_vhd,'begin');
      writeln(F_vhd,'  pSync:  PROCESS(clk,rst)');
      writeln(F_vhd,'          BEGIN');

      s:= '            if rst = ' + #$27 + Brst + #$27 + ' then z <= ' +
          rstzustand + ';';
      writeln(F_vhd,s);
      s:= '               elsif (clk' + #$27 + 'event and clk = ' +
                                #$27 + Bclk + #$27 + ') then';
      writeln(F_vhd,s);

      if atyp = false then  //Mealy
      begin
        writeln(F_vhd,'                     z <= zn;');
        writeln(F_vhd,'            end if;');
        writeln(F_vhd,'');
      end
      else begin
             if TM.Count > 0 then
             begin
               for i:= 0 to TM.Count-1 do
               begin
                 GetStateData(Z,E,ZN,TM.Strings[i]);
                 s:='                     ';
                 if i = 0 then s:= s + 'if   '
                          else s:= s + 'elsif';
                 s:= s + ' z = ' + Z + ' and x = ' + E + ' then z <= ' + ZN + ';';
                 writeln(F_vhd,s);
               end;
             end;
             writeln(F_vhd,'                     end if;');
             writeln(F_vhd,'            end if;');
           end;

      writeln(F_vhd,'          END PROCESS pSync;');
      writeln(F_vhd,'');


      if atyp = false then  //Mealy
      begin
        writeln(F_vhd,'  pASync: PROCESS(z,x)');
        writeln(F_vhd,'          BEGIN');

        //Automatenbeschreibung
        if TM.Count > 0 then
        begin
          writeln(F_vhd,'            case z is');
          for i:= 0 to VZ.Count-1 do
          begin
            ZX:= GetState(VZ.Strings[i]);
            s:='              when ';
            s:= s + ZX;
            len:= length(s) + 4;
            s:= s + ' => case x is ';
            writeln(F_vhd,s);

            lzs:='';
            for n:= 1 to len do
              lzs:= lzs + ' ';

            for x:= 0 to VE.Count-1 do
            begin
              EX:= GetState(VE.Strings[x]);
              k:= 0;
              b:= true;
              while ((b) and (TM.Count > 0)) do
              begin
                GetStateDataMealy(Z,E,ZN,A,TM.Strings[k]);
                inc(k);
                if ((ZX = Z) and (EX = E)) then b:= false;
                if K = TM.Count then b:= false;
              end;

              s:= lzs + '  when ' + EX + ' => y <= ' + A + '; zn <= ' + ZN + ';';
              writeln(F_vhd,s);
            end;

            s:= lzs + '  when others => y <= yx; zn <= zx;';
            writeln(F_vhd,s);
            s:= lzs + 'end case;';
            writeln(F_vhd,s);
          end;
          s:= '            ';
          writeln(F_vhd,s + '  when others => y <= yx; zn <= zx;');
          writeln(F_vhd,s + 'end case;');
        end;
      end
      else begin
             writeln(F_vhd,'  pASync: PROCESS(z)');
             writeln(F_vhd,'          BEGIN');

             //Automatenbeschreibung
             if TA.Count > 0 then
             begin
               for i:= 0 to TA.Count-1 do
               begin
                 s:='            ';
                 if i = 0 then s:= s + 'if   '
                          else s:= s + 'elsif';
                 Z:= GetState(TA.Strings[i]);
                 s:= s + ' z = ' + z + ' then y <= ' + GetOutSignalfromState(Z) + ';';
                 writeln(F_vhd,s);
               end;
               writeln(F_vhd,'            end if;');
             end;
           end;

      writeln(F_vhd,'          END PROCESS pASync;');
      writeln(F_vhd,'');

      writeln(F_vhd,'end Behavioral;');
      writeln(F_vhd,'');

      {$I-}
      closefile(F_vhd);
      {$I+}
    end;
  end;
end;

procedure TAutomatForm.Hilfe1Click(Sender: TObject);
begin
  if atyp = true then Application.HelpJump('3000')
                 else Application.HelpJump('4000');
end;

end.
