unit u_komponente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, u_signals;

type
  TKomponenteForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    FileCB: TComboBox;
    KommentarCB: TCheckBox;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
    srcpath     : string;
    InsertDatei : string;
  public
    { Public-Deklarationen }
    procedure Init(workdir : string; Datei : string);
  end;

var
  KomponenteForm: TKomponenteForm;

implementation

{$R *.DFM}

procedure TKomponenteForm.Init(workdir : string; Datei : string);
var weg1,s : string;
       dir : Tsearchrec;
       err : integer;
begin
  srcpath:= workdir;
  InsertDatei:= datei;
  s:= uppercase(extractfilename(datei));
  weg1:=concat(srcpath,'*.vhd');
  err:=findfirst(weg1,$3f,dir);
  while err = 0 do
  begin
    if uppercase(dir.name) <> s then FileCB.Items.Add(dir.name);
    err:=findnext(dir);
  end;
  FileCB.ItemIndex:= 0;
end;

procedure TKomponenteForm.FormCreate(Sender: TObject);
begin
  FileCB.Clear;
  srcpath:='';
  InsertDatei:='';
end;

procedure TKomponenteForm.FormResize(Sender: TObject);
var x : integer;
begin
  if width < 4* Button2.Width then width:= 4* Button2.Width;
  x:= width div 2;
  Button2.Left:= (x - Button2.Width) div 2;
  Button1.Left:= x+ (x - Button2.Width) div 2;
  FileCB.Width:= width - FileCB.Left*2;
  if  height < FileCB.Height *10 then Height:= FileCB.Height * 10;
end;

procedure TKomponenteForm.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TKomponenteForm.Button1Click(Sender: TObject);
var src,s,sx  : string;
    i,x       : integer;
    ts        : TSignal;
    Fin       : Textfile;
    datstr,portstr,compstr : TStringList;
    b,b1,b2,b3 : boolean;
begin
  if FileCB.Items.Count > 0 then
  begin
    src:= FileCB.Items.Strings[FileCB.ItemIndex];
    if ((src <> '') and (InsertDatei <> '')) then
    begin
      datstr:= TStringList.Create;
      src:= srcpath + src;
      ts:= TSignal.Create(src);

      assignfile(Fin,InsertDatei);
      {$I-}
      reset(Fin);
      {$I+}
      if ioresult = 0 then
      begin
        while not eof(Fin) do
        begin
          readln(Fin,s);
          datstr.Add(s);
        end;
        {$I-}
        closefile(Fin);
        {$I+}
      end;

      //Einfuegen
      if datstr.Count > 0 then
      begin
        {$I-}
        rewrite(Fin);
        {$I+}
        if ioresult = 0 then
        begin
          b:= false;
          b1:= false;
          b2:= false;
          b3:= true;
          for i:= 0 to datstr.Count-1 do
          begin
            s:= datstr.Strings[i];

            if ((b3 = true) and (pos('BEGIN',uppercase(s)) > 0)) then
            begin
              b3:= false;
              sx:= ts.bound(0);
              if sx <> '' then
              begin
                writeln(FIN,sx);
                writeln(FIN,'');
              end;
            end;

            writeln(Fin,s);
            sx:= uppercase(s);
            if pos('ARCHITECTURE',sx) > 0 then
            begin
              b:= true;
              b1:= true;
            end;
            if b = true then
            begin

              if b1 = true then   //Component einfuegen
              begin
                compstr:= ts.componentdef(0);
                if compstr.Count > 0 then
                begin
                  for x:= 0 to compstr.Count-1 do
                  begin
                    writeln(Fin,compstr.Strings[x]);
                  end;
                end;
                writeln(Fin,'');
                b1:= false;
              end;

              if pos('BEGIN',sx) > 0 then
              begin
                b2:= true;
                //Insertposition Port map einfuegen
                portstr:= ts.MapPort(3,KommentarCB.Checked);
                if portstr.Count > 0 then
                begin
                  for x:= 0 to portstr.Count-1 do
                  begin
                    writeln(Fin,portstr.Strings[x]);
                  end;
                end;
                b:= false;
              end;

              if ((b2 = true) and (pos('END',sx) > 0)) then
              begin
                b:= false;
                b2:= false;
              end;  
            end;
          end;
          {$I-}
          closefile(Fin);
          {$I+}
        end;
      end;

      datstr.Free;
      ts.Free;
    end;
  end;
  close;
end;

end.
